# -*- coding: utf-8 -*-

# -*- coding: utf-8 -*-
from __future__ import unicode_literals
import uno
import inspect
import locale

from com.sun.star.beans import PropertyValue


class LanguageInit:
	language = "IT_"
	
	def __init__(self):
		ctx = XSCRIPTCONTEXT.getComponentContext()
		smgr = ctx.getServiceManager()

		oConfigProv = smgr.createInstance("com.sun.star.configuration.ConfigurationProvider")
		prop = []
		arg =  PropertyValue(
			Name = "nodepath",
			Value = "org.openoffice.Setup/L10N/"
		)
		prop.append(arg)
		getRegContent = oConfigProv.createInstanceWithArguments("com.sun.star.configuration.ConfigurationAccess", prop)

		language = getRegContent.getByName("ooLocale").upper() + "_"
		self.IT_TitleFirstPage = "Imposta Prima Pagina"
		self.IT_OptionLabel1 = "Imposta la Prima Pagina e la successiva con lo stile Prefefinito"
		self.IT_OptionLabel2 = "Imposta tre pagine: 1) Prima pagina, 2) Stile predefinito, 3) Pagina destra"
		self.IT_OptionLabel3 = "Imposta la Prima Pagina, la seconda con lo stile Prefefinito e le successive saranno Pagina Destra/Sinistra"
		self.IT_CancelLabel = "Annulla"
		self.IT_TitleInformation = "Informazioni"
		self.IT_labelInformation = "Per qualsiasi informazione o segnalazione potete contattare:"
		self.IT_labelEmail = "antonio.faccioli@studiostorti.com"
		self.IT_heightPage = "Altezza"
		self.IT_widthPage = "Larghezza"
		self.IT_infoGroup = "Informazioni sullo stile applicato su questa pagina:"

		self.EN_TitleFirstPage = "Set First Page"
		self.EN_OptionLabel1 = "Set the First Page and the next with the Standard style"
		self.EN_OptionLabel2 = "Sets three pages: 1) First, 2) Standard style, 3) Right page"
		self.EN_OptionLabel3 = "Set the First Page, the second with the Standard style and later will be left/right page"
		self.EN_CancelLabel = "Cancel"
		self.EN_TitleInformation = "Information"
		self.EN_labelInformation = "You can contact for any information or report:"
		self.EN_labelEmail = "antonio.faccioli@studiostorti.com"
		self.EN_heightPage = "Height page"
		self.EN_widthPage = "Width page"
		self.EN_infoGroup = "Style information applied to this page:"
		
		self.DE_TitleFirstPage = "Set Erste Seite"
		self.DE_OptionLabel1 = "Legen Sie die erste Seite und die nächste mit dem Standard-Stil"
		self.DE_OptionLabel2 = "Setzt drei seiten: 1) Zuerst 2) Standard-Stil, 3) Rechte Seite"
		self.DE_OptionLabel3 = "Legen Sie die erste Seite, die zweite mit dem Standard-Stil und später nach links / rechts Seite werden"
		self.DE_CancelLabel = "Stornieren"
		self.DE_TitleInformation = "Informationen"
		self.DE_labelInformation = "Sie können für jede Information oder berichten kontaktieren:"
		self.DE_labelEmail = "antonio.faccioli@studiostorti.com"
		self.DE_heightPage = "Höhe Seite"
		self.DE_widthPage = "Breite Seite"
		self.DE_infoGroup = "Style-Informationen auf dieser Seite angewendet:"
		
		self.FR_TitleFirstPage = "Définir la première page"
		self.FR_OptionLabel1 = "Définissez la première page et la suivante avec le style par défaut"
		self.FR_OptionLabel2 = "Définit trois pages: 1) Tout d'abord, 2) le style par défaut, 3) Page de droite"
		self.FR_OptionLabel3 = "Définissez la première page, le second avec le style par défaut et la page suivante sera gauche/droite"
		self.FR_CancelLabel = "Annuler"
		self.FR_TitleInformation = "Information"
		self.FR_labelInformation = "Vous pouvez contacter pour toute information ou rapport:"
		self.FR_labelEmail = "antonio.faccioli@studiostorti.com"
		self.FR_heightPage = "Page Hauteur"
		self.FR_widthPage = "Page Largeur"
		self.FR_infoGroup = "Des informations de style appliqué à cette page:"
		
		self.ES_TitleFirstPage = "Impuesto primera página"
		self.ES_OptionLabel1 = "Coloque la primera página y la siguiente con el estilo Estándar"
		self.ES_OptionLabel2 = "Establece tres páginas: 1) En primer lugar, 2) el estilo por defecto, 3) Página derecha"
		self.ES_OptionLabel3 = "Coloque la primera página, la segunda con el estilo por defecto y más tarde será la izquierda / derecha página"
		self.ES_CancelLabel = "Cancelar"
		self.ES_TitleInformation = "Información"
		self.ES_labelInformation = "Puede ponerse en contacto para cualquier información o informe:"
		self.ES_labelEmail = "antonio.faccioli@studiostorti.com"
		self.ES_heightPage = "Altura de la página"
		self.ES_widthPage = "Ancho de página"
		self.ES_infoGroup = "Información de estilo aplicado a esta página:"
		
		self.PT_TitleFirstPage = "Definir Primeira Página"
		self.PT_OptionLabel1 = "Coloque a primeira página ea próxima com o estilo padrão"
		self.PT_OptionLabel2 = "Define três páginas: 1) primeira página, 2) estilo padrão, 3) Página direita"
		self.PT_OptionLabel3 = "Coloque a primeira página, o segundo com o estilo padrão e, posteriormente, será para a esquerda / direita da página"
		self.PT_CancelLabel = "Cancelar"
		self.PT_TitleInformation = "Informação"
		self.PT_labelInformation = "Você pode entrar em contato para qualquer informação ou relatório:"
		self.PT_labelEmail = "antonio.faccioli@studiostorti.com"
		self.PT_heightPage = "Altura da página"
		self.PT_widthPage = "Largura da página"
		self.PT_infoGroup = "Informações de estilo aplicado a esta página:"
		
	def getLocalString(self, loc):
		return (getattr(self, self.language + loc))


#restituisce la larghezza della pagina
def width():
	ctx = XSCRIPTCONTEXT.getDocument()
	cur = ctx.getCurrentController().getViewCursor()
	
	page = ctx.StyleFamilies.getByName("PageStyles").getByName(cur.PageStyleName)
	return page.Width

#restituisce l'altezza della pagina
def height():
	ctx = XSCRIPTCONTEXT.getDocument()
	cur = ctx.getCurrentController().getViewCursor()
	
	page = ctx.StyleFamilies.getByName("PageStyles").getByName(cur.PageStyleName)
	return page.Height

#restituisce il nome dello stile della pagina
def displayName():
	ctx = XSCRIPTCONTEXT.getDocument()
	cur = ctx.getCurrentController().getViewCursor()
	
	page = ctx.StyleFamilies.getByName("PageStyles").getByName(cur.PageStyleName)
	return page.DisplayName

#resituisce la dialog box con tutte le info della pagina
def info(*args):
	x = LanguageInit()
	ctx = XSCRIPTCONTEXT.getComponentContext()
	smgr = ctx.getServiceManager()
	
	oConfigProv = smgr.createInstance("com.sun.star.configuration.ConfigurationProvider")
	#org.openoffice.Setup/L10N/
	prop = []
	arg =  PropertyValue(
		Name = "nodepath",
		Value = "org.openoffice.Setup/L10N/"
	)
	prop.append(arg)
	getRegContent = oConfigProv.createInstanceWithArguments("com.sun.star.configuration.ConfigurationAccess", prop)
	#writeMetodi(getRegContent)
	sLocale = getRegContent.getByName("ooLocale")
	
	
	#creazione dell'istanza della dialog
	dp = smgr.createInstance("com.sun.star.awt.DialogProvider")
	#creazione della dialog Information
	dlg = dp.createDialog("vnd.sun.star.script:PortraitOrLandscape.Information?location=application")
	#prelevo il controllo infoGroup
	oInfoGrp = dlg.getControl("infoGroup")
	oInfoGrp.Text = x.getLocalString("infoGroup")
	#prelevo il controllo infoStyle
	oinfoStyle = dlg.getControl("infoStyle")
	oinfoStyle.Text = displayName()
	#prelevo il controllo infoSize
	oinfoSize = dlg.getControl("infoSize")
	oinfoSize.Text = ("{labelAltezza}: {altezza} mm - {labelLung}: {lunghezza} mm").format(labelAltezza=x.getLocalString("heightPage"), altezza=height(), labelLung=x.getLocalString("widthPage"), lunghezza=width())
	#prelevo il controllo labelInformation
	oinfoLabel = dlg.getControl("labelInformation")
	#oinfoLabel.Text = ("Per qualsiasi informazione o segnalazione potete contattare:")
	oinfoLabel.Text = x.getLocalString("labelInformation")
	#prelevo il controllo labelEmail
	emailLabel = dlg.getControl("labelEmail")
	emailLabel.Text = "antonio.faccioli@studiostorti.com"
	#visualizzo la dialog
	dlg.execute()


#prova
def myDialog(*args):
    ctx = XSCRIPTCONTEXT.getComponentContext()
    smgr = ctx.getServiceManager()
    oDM = smgr.createInstance("com.sun.star.awt.UnoControlDialogModel")
    oDM.Width = 540
    oDM.Height = 550
    okBtn = oDM.createInstance('com.sun.star.awt.UnoControlButtonModel')
    okBtn.Width = 300
    okBtn.Height = 300
    #okBtn.Label = 
    
    okBtn.PositionX = 50
    oDM.insertByName("my button", okBtn);
    oDialog = smgr.createInstance("com.sun.star.awt.UnoControlDialog")
    oDialog.setModel(oDM)
    oDialog.setVisible(True)
    oDialog.execute()

#cambia l'orientamento della pagina
def changeOrientation(*args):
	ctx = XSCRIPTCONTEXT.getDocument()
	cur = ctx.getCurrentController().getViewCursor()
	#mi faccio restituire lo stile della pagina
	page = ctx.StyleFamilies.getByName("PageStyles").getByName(ctx.getCurrentController().getViewCursor().PageStyleName)
	#writeMetodi(page)
	#controllo se è Landscape
	if page.IsLandscape:
		#se si applico lo stile Orrizzontale
		styleApply(0)
	else:
		#altrimenti applico verticale
		styleApply(9)
	return None
	
	cur = ctx.getCurrentController()
	#prelevo il frame
	#frame = cur.getFrame()
	
	#styleName = ctx.StyleFamilies.getByName("PageStyles").getByIndex(indexStyle).DisplayName
	
def writeMetodi(obj):
	#nomeFile = obj.__class__.__name__
	#module = obj.__class__.__module__
	#if module is None or module == str.__class__.__module__:
	#	nomeFile = obj.__class__.__name__  # Avoid reporting __builtin__
	#else:
	#	nomeFile = module + '.' + obj.__class__.__name__
	if inspect.isclass(obj):
		nomeFile = obj.__class__.__name__
	else:
		nomeFile = "OKKK"
		
	f = open("c:\\" + nomeFile + ".txt", "w")
	for prop in dir(obj):
		f.write(prop + "\n")
	f.close()

#funzione che applica l'orientamento
def styleApply(indexStyle):
	ctx = XSCRIPTCONTEXT.getDocument()
	cur = ctx.getCurrentController()
	#prendo il frame
	frame = cur.getFrame()
	#prendo lo stile
	styleName = ctx.StyleFamilies.getByName("PageStyles").getByIndex(indexStyle).DisplayName
	smgr = XSCRIPTCONTEXT.getComponentContext().getServiceManager()
	#prendo di dispatcher 
	dsp = smgr.createInstance("com.sun.star.frame.DispatchHelper")
	#dsp = smgr.createInstanceWithContext("com.sun.star.frame.DispatchHelper", ctx)
	#imposto le proprietà
	prop = []
	arg =  PropertyValue(
		Name = "Template",
		Value = styleName
	)
	arg2 = PropertyValue(
		Name = "Family",
		Value = 8
	)
	prop.append(arg)
	prop.append(arg2)
	#applico lo stile cambiato
	dsp.executeDispatch(frame, ".uno:StyleApply", "", 0, prop)
	return None

def scrivi(*args):
	ctx = XSCRIPTCONTEXT.getDocument()
	cur = ctx.getCurrentController()
	frame = cur.getFrame()
	writeMetodi(frame)

def mia_inputbox(*args):
	inputbox("Please input some value", "Input", "Default value")


def inputbox(message, title="", default="", x=None, y=None):
    """ Shows dialog with input box.
        @param message message to show on the dialog
        @param title window title
        @param default default value
        @param x dialog positio in twips, pass y also
        @param y dialog position in twips, pass y also
        @return string if OK button pushed, otherwise zero length string
    """
    WIDTH = 600
    HORI_MARGIN = VERT_MARGIN = 8
    BUTTON_WIDTH = 100
    BUTTON_HEIGHT = 26
    HORI_SEP = VERT_SEP = 8
    LABEL_HEIGHT = BUTTON_HEIGHT * 2 + 5
    EDIT_HEIGHT = 24
    HEIGHT = VERT_MARGIN * 2 + LABEL_HEIGHT + VERT_SEP + EDIT_HEIGHT
    import uno
    from com.sun.star.awt.PosSize import POS, SIZE, POSSIZE
    from com.sun.star.awt.PushButtonType import OK, CANCEL
    from com.sun.star.util.MeasureUnit import TWIP
    ctx = uno.getComponentContext()
    def create(name):
        return ctx.getServiceManager().createInstanceWithContext(name, ctx)
    dialog = create("com.sun.star.awt.UnoControlDialog")
    dialog_model = create("com.sun.star.awt.UnoControlDialogModel")
    dialog.setModel(dialog_model)
    dialog.setVisible(False)
    dialog.setTitle(title)
    dialog.setPosSize(0, 0, WIDTH, HEIGHT, SIZE)
    def add(name, type, x_, y_, width_, height_, props):
        model = dialog_model.createInstance("com.sun.star.awt.UnoControl" + type + "Model")
        dialog_model.insertByName(name, model)
        control = dialog.getControl(name)
        control.setPosSize(x_, y_, width_, height_, POSSIZE)
        for key, value in props.items():
            setattr(model, key, value)
    label_width = WIDTH - BUTTON_WIDTH - HORI_SEP - HORI_MARGIN * 2
    add("label", "FixedText", HORI_MARGIN, VERT_MARGIN, label_width, LABEL_HEIGHT, 
        {"Label": str(message), "NoLabel": True})
    add("btn_ok", "Button", HORI_MARGIN + label_width + HORI_SEP, VERT_MARGIN, 
            BUTTON_WIDTH, BUTTON_HEIGHT, {"PushButtonType": OK, "DefaultButton": True})
    add("btn_cancel", "Button", HORI_MARGIN + label_width + HORI_SEP, VERT_MARGIN + BUTTON_HEIGHT + 5, 
            BUTTON_WIDTH, BUTTON_HEIGHT, {"PushButtonType": CANCEL})
    add("edit", "Edit", HORI_MARGIN, LABEL_HEIGHT + VERT_MARGIN + VERT_SEP, 
            WIDTH - HORI_MARGIN * 2, EDIT_HEIGHT, {"Text": str(default)})
    frame = create("com.sun.star.frame.Desktop").getCurrentFrame()
    window = frame.getContainerWindow() if frame else None
    dialog.createPeer(create("com.sun.star.awt.Toolkit"), window)
    if not x is None and not y is None:
        ps = dialog.convertSizeToPixel(uno.createUnoStruct("com.sun.star.awt.Size", x, y), TWIP)
        _x, _y = ps.Width, ps.Height
    elif window:
        ps = window.getPosSize()
        _x = ps.Width / 2 - WIDTH / 2
        _y = ps.Height / 2 - HEIGHT / 2
    dialog.setPosSize(_x, _y, 0, 0, POS)
    edit = dialog.getControl("edit")
    edit.setSelection(uno.createUnoStruct("com.sun.star.awt.Selection", 0, len(str(default))))
    edit.setFocus()
    ret = edit.getModel().Text if dialog.execute() else ""
    dialog.dispose()


def messagebox(ctx, parent, message, title, message_type, buttons):
    """ Show message in message box. """
    toolkit = parent.getToolkit()
    older_imple = check_method_parameter(
        ctx, "com.sun.star.awt.XMessageBoxFactory", "createMessageBox", 
        1, "com.sun.star.awt.Rectangle")
    if older_imple:
        msgbox = toolkit.createMessageBox(
            parent, Rectangle(), message_type, buttons, title, message)
    else:
        message_type = uno.getConstantByName("com.sun.star.awt.MessageBoxType." + {
            "messbox": "MESSAGEBOX", "infobox": "INFOBOX", 
            "warningbox": "WARNINGBOX", "errorbox": "ERRORBOX", 
            "querybox": "QUERYBOX"}[message_type])
        msgbox = toolkit.createMessageBox(
            parent, message_type, buttons, title, message)
    n = msgbox.execute()
    msgbox.dispose()
    return n
 
 
def check_method_parameter(ctx, interface_name, method_name, param_index, param_type):
    """ Check the method has specific type parameter at the specific position. """
    cr = create_service(ctx, "com.sun.star.reflection.CoreReflection")
    try:
        idl = cr.forName(interface_name)
        m = idl.getMethod(method_name)
        if m:
            info = m.getParameterInfos()[param_index]
            return info.aType.getName() == param_type
    except:
        pass
    return False

#funzioni che vengono esposte
g_exportedScripts = info, changeOrientation, scrivi, mia_inputbox




